<script setup lang="ts">
import AutoComplete from "primevue/autocomplete";
import type {PreparedVersion} from "@/entities/Repository/PreparedVersion";
import {ref} from "vue";
import {VersionApiHandler} from "@/handlers/VersionApiHandler";
import type Version from "@/entities/Repository/Version";

const props = defineProps<{
  preparedVersion: PreparedVersion,
}>()

const versions: ref<Array<Version>> = ref<Array<Version>>([]);
const versionApiHandler = new VersionApiHandler();

const searchVersion = () => {
  versionApiHandler.list({'repository_released_version': props.preparedVersion.repository.uri})
      .then((versionsList: Array<Version>) => versions.value = versionsList)
}

</script>

<template>
  <AutoComplete
      v-model="preparedVersion.targetVersion"
      :suggestions="versions.value"
      @complete="searchVersion"
      dropdown
      inputClass="w-full"
      optionLabel="code"
      placeholder="Recherchez une version"
      :invalid="!preparedVersion.targetVersion"
      :inputProps="{required: true, autofocus: true}"
  />
</template>